/************************************************************************

         Filename   :   pq_Node.h
         Version    :   1.0  1997
         Author     :   Sebastian Leipert
         Language   :   C++

************************************************************************/
#ifndef INTERNALNODE_H
#define INTERNALNODE_H
#include "pqNode.h"



template<class T,class X,class Y>
class internalNode : public pqNode<T,X,Y> {

   int              _mark;  
   internalKey<T,X,Y>* _pointerToInternal;
   int              _status;
   int              _type;


public:

internalNode(int count,int typ, int stat, internalKey<T,X,Y>* internalPtr,
                                          pqNodeKey<T,X,Y>* infoPtr)
   :pqNode<T,X,Y>(count,infoPtr)
{
   _type = typ;
   _status = stat;
   _mark = UNMARKED;

   _pointerToInternal = internalPtr;
   internalPtr->setNodePointer(this);
   
}


internalNode(int count,int typ, int stat, internalKey<T,X,Y>* internalPtr)
   :pqNode<T,X,Y>(count)
{
   _type = typ;
   _status = stat;
   _mark = UNMARKED;

   _pointerToInternal = internalPtr;
   internalPtr->setNodePointer(this);
   
}


internalNode(int count,int typ, int stat, pqNodeKey<T,X,Y>* infoPtr)
   :pqNode<T,X,Y>(count,infoPtr)
{
   _type = typ;
   _status = stat;
   _mark = UNMARKED;

   _pointerToInternal = NULL;
   
}


internalNode(int count,int typ, int stat) :pqNode<T,X,Y>(count)
{
   _type = typ;
   _status = stat;
   _mark = UNMARKED;

   _pointerToInternal = NULL;
   
}


virtual ~internalNode()
{ }


virtual internalKey<T,X,Y>* getInternal() const
{
   return _pointerToInternal;
}


virtual leafKey<T,X,Y>* getKey() const
{
   return NULL;
}


virtual int mark() const
{
   return _mark;
}


virtual void mark(int Mark)
{
   _mark = Mark;
}


virtual int setInternal(internalKey<T,X,Y>* pointerToInternal)
{
   _pointerToInternal = pointerToInternal;
   if (pointerToInternal != NULL)
   {
      _pointerToInternal->setNodePointer(this);
      return TRUE;
   }
   else
      return FALSE;
}


virtual int setKey(leafKey<T,X,Y>* pointerToKey)
{
   if (pointerToKey != NULL)
      return FALSE;
   else
      return TRUE;
}


virtual int status() const
{
   return _status;
}


virtual void status(int Status)
{
   _status = Status;
}


virtual int type() const
{
   return _type;
}


virtual void type(int Type)
{
   _type = Type;
}

};




#endif


