/************************************************************************

         Filename   :   leaf.h
         Version    :   1.0  1997
         Author     :   Sebastian Leipert
         Language   :   C++

************************************************************************/
#ifndef LEAF_H
#define LEAF_H
#include "pqNode.h"



template<class T,class X,class Y> 
class leaf : public pqNode<T,X,Y> {
   
   int          _mark;
   leafKey<T,X,Y>*  _pointerToKey;
   int          _status;

public:




leaf(int count, int stat, leafKey<T,X,Y>* keyPtr, pqNodeKey<T,X,Y>* infoPtr)
   :pqNode<T,X,Y>(count,infoPtr)
{
   _status = stat;
   _pointerToKey = keyPtr;
   _mark = UNMARKED;


   keyPtr->setNodePointer(this);
   
} 


leaf(int count, int stat, leafKey<T,X,Y>* keyPtr) :pqNode<T,X,Y>(count)
{
   _status = stat;
   _pointerToKey = keyPtr;
   _mark = UNMARKED;


   keyPtr->setNodePointer(this);
   
} 


virtual ~leaf() { }


virtual internalKey<T,X,Y>* getInternal() const
{
   return NULL;
}


virtual leafKey<T,X,Y>* getKey() const
{
   return _pointerToKey;
}


virtual int mark() const
{
   return _mark;
}


virtual void mark(int Mark) 
{
   _mark = Mark;
}


virtual int setInternal(internalKey<T,X,Y>* pointerToInternal) 
{
   if (pointerToInternal != NULL)
      return FALSE;
   else
      return TRUE;
}


virtual int setKey(leafKey<T,X,Y>* pointerToKey)
{
   _pointerToKey = pointerToKey;
   if (pointerToKey != NULL)
   {
      _pointerToKey->setNodePointer(this);
      return TRUE;
   }
   else
      return FALSE;
}


virtual int status() const
{
   return _status;
}


virtual void status(int Status)
{
   _status = Status;
}


virtual int type() const
{
   return LEAF;
}


virtual void type(int Type) 
{
   Type = Type;
}

};



#endif


