/************************************************************************

         Filename      :   basicList.h
         Version       :   1.0.4
         Author        :   Christoph Buchheim
         Modified      :   Sebastian Leipert 
         Last Modifed  :   15/12/99  1.0.3
         Language      :   C++

************************************************************************/

#ifndef BASICLIST_H
#define BASICLIST_H


/*
template<class T> class basicList;
template<class T> class linkedList;  // Needed for c-planarity test in AGD
*/


template<class T> 
class element{
/*
  friend class basicList<T>;
  friend class linkedList<T>;        // Needed for c-planarity test in AGD
*/

//private:

public:
  T item;
  element<T>* next;
};

template<class T> class basicList {

protected:

  element<T> *first,*actual;
  int size;

public:

  basicList();
  ~basicList();
  int in(T);
  int out(T&);
  T   out();
  void append(basicList<T>*);
  void reverse();
  int count() const;
  void reset();
  void clear();

};

template<class T>
basicList<T>::basicList():first(0),actual(0),size(0) {};

template<class T>
basicList<T>::~basicList() {
  clear();
}

template<class T>
int basicList<T>::in(T newItem) {
  element<T>* newElement=new element<T>;
  if(!newElement) return 0;
  newElement->item=newItem;
  newElement->next=first;
  first=newElement;
  size++;
  return 1;
}

template<class T>
int basicList<T>::out(T& actualItem) {
  if(!actual) return 0;
  actualItem=actual->item;
  actual=actual->next;
  return 1;
}

/********************************
 changed by S. Leipert in 11.1997
 extra funtion added
*********************************/

template<class T>
T basicList<T>::out() {
  if(!actual) return 0;
  
  T actualItem = actual->item;
  actual       = actual->next;

  return actualItem;
}

/********************************
 changed by S. Leipert in 11.1997
 end changes
*********************************/



template<class T>
void basicList<T>::append(basicList<T>* otherList) {
  element<T> *newFirst,
             *lastElement,
             *newElement;
  T actualItem;
  otherList->reset();
  if(!otherList->out(actualItem)) return;
  newFirst=lastElement=newElement=new element<T>;
  newElement->item=actualItem;
  size++;
  while(otherList->out(actualItem)) {
    newElement=new element<T>;
    newElement->item=actualItem; 
    size++;
    lastElement->next=newElement;
    lastElement=newElement;
  }
  lastElement->next=first;
  first=newFirst;
}

template<class T>
void basicList<T>::reverse() {
  element<T> *actualElement=first,
             *nextElement,
             *previousElement=0;
  while(actualElement) {
    nextElement=actualElement->next;
    actualElement->next=previousElement;
    previousElement=actualElement;
    actualElement=nextElement;
  }
  first=previousElement;
}

template<class T>
int basicList<T>::count() const {
  return size;
}

template<class T>
void basicList<T>::reset() {
  actual=first;
}

template<class T>
void basicList<T>::clear() {
  while((actual=first)) {
    first=actual->next;
    delete actual;
  }
  size=0;
}















#endif

