/*******************************************************************************
+
+  AGD 1.2
+
+
+  label.c
+
+
+  Copyright (c) 1998-2003
+  by  Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/



// label.cpp: implementation of the label class.
//
//////////////////////////////////////////////////////////////////////

#include "label.h"

using namespace leda;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

int label_struct::size()
{
  return pendants_.size ();
}

block label_struct::first_pendant()
{
  return pendants_.head ();
}

label_struct::label_struct(cutpoint cp, block p, STOP_CAUSE s) :
				sc_(s), head_ (cp)
{
 pendants_.push (p);
 parent_ = nil;
}

bool label_struct::is_clabel()
{
	if ( !parent_)
		return true;
	return false;
}

 block label_struct::get_pendant(int number)
{
	return pendants_.inf (pendants_.get_item (number));
}

 void label_struct::remove_pendant(block p)
{
	pendants_.del_item (pendants_.search (p));
}

 STOP_CAUSE label_struct::stop_cause()
{
 return sc_;
}

 bool label_struct::is_blabel()
{
 if ( parent_ )
	 return true;
 return false;
}

label_struct::label_struct(block p1, block p2, block b, cutpoint head)
{
  parent_ = b;
  sc_ = B_DEGREE;
  head_ = head;
  pendants_.push (p1);
  pendants_.push (p2);
}

 void label_struct::stop_cause(STOP_CAUSE sc)
{
 sc_ = sc;
}

 void label_struct::change2clabel(cutpoint new_head)
{
  parent_ = nil;
  head_ = new_head;
}

 block label_struct::last_pendant()
{
	return pendants_.tail ();
}

 cutpoint label_struct::head()
{
  return head_;
}

 bc_node label_struct::parent()
{
  if ( parent_ )
	return parent_;
  return head_;
}

 void label_struct::add_pendant(block b)
{
  pendants_.append (b);
}

 void label_struct::delete_all_pendants()
{
  pendants_.clear ();
}
//*************************************************************
