/*******************************************************************************
+
+  AGD 1.2
+
+
+  CGGridLayout.c
+
+
+  Copyright (c) 1998-2003
+  by  Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/


//-------------------------------------------------------------------
//
//                          CGGridLayout.c
//
//    author: Dirk Luetke-Huettmann
//    date:   may 1999
//-------------------------------------------------------------------

#include <AGD/GraphCopy.h>
#include <AGD/CGGridLayout.h>
#include <LEDA/internal/std/math.h>

using namespace leda;

const IRect CGGridLayout::bounding_box(void) {
  Cluster* cl;
  int xmin, xmax, ymin, ymax;

  IRect gbbox = GridLayout::bounding_box();

  list<Cluster *> clusters = _ccgp->all_clusters();
  if(clusters.empty()) return IRect();
  
  xmin = gbbox.left();
  xmax = xmin + gbbox.width();
  ymin = gbbox.bottom();
  ymax = ymin + gbbox.height();

  forall(cl, clusters) {
    if( xmin > x(cl))              xmin = x(cl);
    if( xmax < x(cl) + width(cl))  xmax = x(cl) + width(cl);
    if( ymin > y(cl))              ymin = y(cl);
    if( ymax < y(cl) + height(cl)) ymax = y(cl) + height(cl);
  }

  return IRect(xmin, xmax, ymin, ymax);
}
