/*******************************************************************************
+
+  AGD 1.2
+
+
+  Cluster.c
+
+
+  Copyright (c) 1998-2003
+  by  Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/


#include <AGD/Cluster.h>

using namespace leda;

//////////////////////////////////////////////////////////////////////////////////
// Class Cluster
//////////////////////////////////////////////////////////////////////////////////

Cluster::Cluster() {
  supercluster = NULL;
}

Cluster::~Cluster() {
  subclusters.clear();
  clusternodes.clear();
}


////////////////////////////////////////////////////////////////////////////////
// removes only a cluster from the list of childclusters
// DOES NOT DELETE THE CLUSTER

void Cluster::remove_subcluster(Cluster* cl_node) {
  list_item cl_item;
  Cluster* cl_child;
    
  forall_items(cl_item, subclusters) {
    cl_child = subclusters.inf(cl_item);
    if(cl_child == cl_node) subclusters.erase(cl_item);
  }
}
////////////////////////////////////////////////////////////////////////////////
//
// removes node <vertex> from the list of cluster vertices

bool Cluster::remove_node(node vertex) {
  list_item cl_item;
  node v;
  
  forall_items(cl_item, clusternodes) {
    v = clusternodes.inf(cl_item);
    if(v == vertex) {
      clusternodes.erase(cl_item);
      return true;
    }
  }
  return false;
}
