/*******************************************************************************
+
+  AGD 1.2
+
+
+  print.c
+
+
+  Copyright (c) 1998-2003
+  by  Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/



#include <AGD/CGraphWin.h>

using namespace leda;

///////////////////////////////////////////////////////////////////////////////
//
//

void CGraphWin::print_gml(ostream &out) {
  gml_print_cluster_tree(rc_p, "  ", out);
}


void CGraphWin::gml_print_cluster_tree(Cluster* cl_parent, string indent, ostream &out) {
  list<Cluster*> cl_children = cl_parent->get_subclusters() ;
  list<node> cl_leaves;
  cluster_info* cli;
  node v;
  Cluster* cl;

  indent += "  ";

  forall(cl, cl_children) {
    cl_leaves = cl->get_nodes();
    cli = cli_cl_map[cl];

    out << indent << "cluster [\n";
    out << indent << "  id " << cli->index << "\n";
    out << indent << "  label \"" << cli->label << "\"\n";
    out << indent << "  graphics [\n";
    out << indent << "    x " << cli->x << "\n";
    out << indent << "    y " << cli->y << "\n";
    out << indent << "    width " << cli->w << "\n";
    out << indent << "    height " << cli->h << "\n";

    out << indent << "    color "; 
    if(cli->cluster_color == red) out << "\"red\"\n";
    else if(cli->cluster_color == blue) out << "\"blue\"\n";
    else out << "\"black\"\n";

    out << indent << "    style ";
    if(cli->cluster_style == cgw_circle) out << "\"circle\"\n";
    else out << "\"rectangle\"\n";

    out << indent << "    borderwidth " << cli->borderwidth << "\n";
    out << indent << "  ]\n";
    if(!cl->get_subclusters().empty()) gml_print_cluster_tree(cl, indent, out);
    if(!cl_leaves.empty()) {
      forall(v, cl_leaves) out << indent << "  vertex \"" << get_user_label(v) << "\"\n";
    }
    out << indent << "]\n";
  }

  if(cl_parent == rc_p) {
    cl_leaves = cl_parent->get_nodes();
    if(!cl_leaves.empty()) {
      forall(v, cl_leaves) out << indent << "vertex \"" << get_user_label(v) << "\"\n";
    }
  }
}
