/*******************************************************************************
+
+  AGD 1.2
+
+
+  PureOrthogonalLayout.c
+
+
+  Copyright (c) 1998-2003
+  by  Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/



//#line 292 "Lweb/OrthoLayout.lw"
#include <AGD/PureOrthogonalLayout.h>

using namespace leda;

PureOrthogonalLayout::PureOrthogonalLayout() : Ovid() { 

  _allowBends = true;
  _containsCages = false;
  _blowUp = false;

  add_precondition(key::four_graph);
  add_precondition(key::connected);
  add_post_rule(key::orthogonal);

}

AGDModule* PureOrthogonalLayout::clone() const { 

  PureOrthogonalLayout *O = new PureOrthogonalLayout;
    
  O->variant(variant());
  O->output_level(output_level());
  O->traditional(traditional());
  O->progressive(progressive());
  O->verify(verify());

  O->set_compactor(compactor.get());

  return O; 
 
}


//#line 327 "Lweb/OrthoLayout.lw"
void PureOrthogonalLayout::preprocessing(OrthogonalRepresentation &) { }

void PureOrthogonalLayout::postprocessing(OrthogonalRepresentation &,
                                          GridLayout &) { }


