/*******************************************************************************
+
+  LEDA 7.0  
+
+
+  _gl_window.c
+
+
+  Copyright (c) 1995-2023
+  by Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/


#include <LEDA/graphics/x_window.h>

#ifdef  LEDA_INSTALL
#define RESTORE_LEDA_INSTALL
#undef  LEDA_INSTALL
#endif

#include <LEDA/graphics/gl_window.h>

#ifdef  RESTORE_LEDA_INSTALL
#define LEDA_INSTALL
#undef  RESTORE_LEDA_INSTALL
#endif


LEDA_BEGIN_NAMESPACE


void  x_opengl_init(int win);
void  x_opengl_start(int win);
void  x_opengl_flush(int win);
void  x_opengl_finish(int win);
void* x_opengl_win_struct(int win);


#ifdef __unix__
gl_window::gl_window() 
{ x_opengl_init(BASE_WINDOW::draw_win); }

gl_window::gl_window(const char * l) : window(l) 
{ x_opengl_init(BASE_WINDOW::draw_win); }

gl_window::gl_window(int w, int h) : window(w,h) 
{ x_opengl_init(BASE_WINDOW::draw_win); }

gl_window::gl_window(int w, int h, const char* l) : window(w,h,l) 
{ x_opengl_init(BASE_WINDOW::draw_win); }

void gl_window::display() { window::display(); }

void gl_window::display(int x, int y) { window::display(x,y); }

void gl_window::display(window& W, int x, int y) { window::display(W,x,y); }

void gl_window::display(int x, int y, window& W) { window::display(W,x,y); }

#else

gl_window::gl_window() {}

gl_window::gl_window(const char * l) : window(l) {}

gl_window::gl_window(int w, int h) : window(w,h)  {}

gl_window::gl_window(int w, int h, const char* l) : window(w,h,l) {}


void gl_window::display()
{ window::display();
  x_opengl_init(BASE_WINDOW::draw_win);
}

void gl_window::display(int x, int y)
{ window::display(x,y);
  x_opengl_init(BASE_WINDOW::draw_win);
}

void gl_window::display(window& W, int x, int y)
{ window::display(W,x,y);
  x_opengl_init(BASE_WINDOW::draw_win);
}

void gl_window::display(int x, int y, window& W)
{ window::display(W,x,y);
  x_opengl_init(BASE_WINDOW::draw_win);
}

#endif

void gl_window::gl_start()  
{ x_opengl_start(BASE_WINDOW::draw_win);  }

void gl_window::gl_flush()
{ x_opengl_flush(BASE_WINDOW::draw_win); }

void gl_window::gl_finish() 
{ gl_flush();
  x_opengl_finish(BASE_WINDOW::draw_win); 
}

LEDA_END_NAMESPACE
