@echo off                                     
set srcd=0
set wdir=mswin          
set make=nmake -nologo  
set opts=mdd

REM if not exist leda.lic exit

if "%1" == "clean" set clean=clean

chdir src

:src1pass

rem libL *******************************************

if not exist core\basic\makefile goto :skip_basic
echo.
echo src\core\basic
chdir core\basic
%make% -i %clean%
chdir ..\..

if not exist core\basic_alg\makefile goto :skip_basic
echo.
echo src\core\basic_alg
chdir core\basic_alg
%make% -i %clean%
chdir ..\..

if not exist core\dict\makefile goto :skip_basic
echo.
echo src\core\dict
chdir core\dict
%make% -i %clean%
chdir ..\..

if not exist core\prio\makefile goto :skip_basic
echo.
echo src\core\prio
chdir core\prio
%make% -i %clean%
chdir ..\..
:skip_basic



if not exist numbers\linalg\makefile goto :skip_numbers
echo.
echo src\numbers\linalg
chdir numbers\linalg
%make% -i %clean%
chdir ..\..

if not exist numbers\misc\makefile goto :skip_numbers
echo.
echo src\numbers\misc
chdir numbers\misc
%make% -i %clean%
chdir ..\..

if not exist numbers\types\makefile goto :skip_numbers
echo.
echo src\numbers\types
chdir numbers\types
%make% -i %clean%
chdir ..\..

if not exist numbers\system\makefile goto :skip_numbers
echo.
echo src\numbers\system
chdir numbers\system
%make% -i %clean%
chdir ..\..

if not exist numbers\asm\x86\makefile goto :skip_numbers
echo.
echo src\numbers\asm\x86
chdir numbers\asm\x86
%make% -i %clean%
chdir ..\..\..
:skip_numbers

if not exist system\makefile goto :skip_system
echo.
echo src\system
chdir system
%make% -i %clean%
chdir ..
:skip_system


rem libG *******************************************

if not exist graph\graph_types\makefile goto :skip_graph_types
echo.
echo src\graph\graph_types
chdir graph\graph_types
%make% -i %clean%
chdir ..\..
:skip_graph_types

if not exist graph\graph_alg\makefile goto :skip_graphs
echo.
echo src\graph\graph_alg
chdir graph\graph_alg
%make% -i %clean%
chdir ..\..

if not exist graph\graph_iso\makefile goto :skip_graph_iso
echo.
echo src\graph\graph_iso
chdir graph\graph_iso
%make% -i %clean%
chdir ..\..
:skip_graph_iso

if not exist graph\graph_draw\makefile goto :skip_graphs
echo.
echo src\graph\graph_draw
chdir graph\graph_draw
%make% -i %clean%
chdir ..\..
:skip_graphs


rem libP *******************************************

if not exist geo\d3_geo\makefile goto :skip_d3geo

if not exist geo\d3_geo\float\makefile goto :skip_d3geo
echo.
echo src\geo\d3_geo\float
chdir geo\d3_geo\float
%make% -i %clean% DFLAGS="-I../generic"
chdir ..\..\..

if not exist geo\d3_geo\rational\makefile goto :skip_d3geo
echo.
echo src\geo\d3_geo\rational
chdir geo\d3_geo\rational
%make% -i %clean% DFLAGS="-I../generic"
chdir ..\..\..

:skip_d3geo


if not exist geo\plane\makefile goto :skip_plane

if not exist geo\plane\float\makefile goto :skip_plane
echo.
echo src\geo\plane\float
chdir geo\plane\float
%make% -i %clean% DFLAGS="-I../generic"
chdir ..\..\..

if not exist geo\plane\rational\makefile goto :skip_plane
echo.
echo src\geo\plane\rational
chdir geo\plane\rational
%make% -i %clean% DFLAGS="-I../generic"
chdir ..\..\..

:skip_plane

if not exist geo\io\makefile goto :skip_io
echo.
echo src\geo\io
chdir geo\io
%make% -i %clean% DFLAGS="-I../generic"
chdir ..\..

:skip_io


if not exist geo\plane_alg\makefile goto :skip_plane_alg

if not exist geo\plane_alg\float\makefile goto :skip_plane_alg
echo.
echo src\geo\plane_alg\float
chdir geo\plane_alg\float
%make% -i %clean% DFLAGS="-I../generic"
chdir ..\..\..

if not exist geo\plane_alg\rational\makefile goto :skip_plane_alg
echo.
echo src\geo\plane_alg\rational
chdir geo\plane_alg\rational
%make% -i %clean% DFLAGS="-I../generic -I../../../../src/geo/plane_alg/generic"
chdir ..\..\..

if not exist geo\plane_alg\real\makefile goto :skip_plane_alg
echo.
echo src\geo\plane_alg\real
chdir geo\plane_alg\real
%make% -i %clean% DFLAGS="-I../generic"
chdir ..\..\..

:skip_plane_alg


:skip_geo


rem libW *******************************************

if not exist graphics\anim\makefile goto :skip_anim
echo .
echo src\graphics\anim
chdir graphics\anim
%make% -i %clean%
chdir ..\..
:skip_anim


if not exist graphics\geowin\makefile goto :skip_geowin
echo.
echo src\graphics\geowin
chdir graphics\geowin
%make% -i  DFLAGS=-DLEDA_IMPORT %clean%
chdir ..\..
:skip_geowin

if not exist graphics\window\makefile goto :skip_graphics
echo.
echo src\graphics\window
chdir graphics\window
%make% -i %clean%
chdir ..\..

if not exist graphics\mswin\makefile goto :skip_graphics
echo.
echo src\graphics\mswin
chdir graphics\mswin
%make% -i %clean%
chdir ..\..

if not exist graphics\graphwin\makefile goto :skip_graphics
echo.
echo src\graphics\graphwin
chdir graphics\graphwin
%make% -i %clean%
chdir ..\..
:skip_graphics


chdir ..


if not exist AGD\src\makefile goto :skip_agd

echo.
echo AGD\src\augmentation
chdir AGD\src\augmentation
%make% -i DFLAGS=-DLEDA_IMPORT %clean%

echo.
echo AGD\src\base
chdir ..\base
%make% -i DFLAGS=-DLEDA_IMPORT %clean%

echo.
echo AGD\src\cgraphwin
chdir ..\cgraphwin
%make% -i DFLAGS=-DLEDA_IMPORT %clean%


echo.
echo AGD\src\cluster_orthogonal
chdir ..\cluster_orthogonal
%make% -i DFLAGS=-DLEDA_IMPORT %clean%

echo.
echo AGD\src\cplanarity
chdir ..\cplanarity
%make% -i DFLAGS=-DLEDA_IMPORT %clean%

echo.
echo AGD\src\isugiyama
chdir ..\isugiyama
%make% -i DFLAGS=-DLEDA_IMPORT %clean%

echo.
echo AGD\src\layout
chdir ..\layout
%make% -i DFLAGS=-DLEDA_IMPORT %clean%

echo.
echo AGD\src\mixed_model
chdir ..\mixed_model
%make% -i DFLAGS=-DLEDA_IMPORT %clean%

echo.
echo AGD\src\orthogonal
chdir ..\orthogonal
%make% -i DFLAGS=-DLEDA_IMPORT %clean%

echo.
echo AGD\src\planar_straight
chdir ..\planar_straight
%make% -i DFLAGS=-DLEDA_IMPORT %clean%

echo.
echo AGD\src\planar_subgraph
chdir ..\planar_subgraph
%make% -i DFLAGS=-DLEDA_IMPORT %clean%

echo.
echo AGD\src\planarity
chdir ..\planarity
%make% -i DFLAGS=-DLEDA_IMPORT %clean%

echo.
echo AGD\src\shelling_order
chdir ..\shelling_order
%make% -i DFLAGS=-DLEDA_IMPORT %clean%

echo.
echo AGD\src\spqr_tree
chdir ..\spqr_tree
%make% -i DFLAGS=-DLEDA_IMPORT %clean%

echo.
echo AGD\src\sugiyama
chdir ..\sugiyama
%make% -i DFLAGS=-DLEDA_IMPORT %clean%

echo.
echo AGD\src\tree_layout
chdir ..\tree_layout
%make% -i DFLAGS=-DLEDA_IMPORT %clean%

chdir ..\..\..
:skip_agd

if %srcd% == 1 goto :end
set srcd=1
chdir src1

if not exist coding\compress\basic\makefile goto :skip_compress
echo.
echo src\coding\compress\basic
chdir coding\compress\basic
%make% -i %clean%
chdir ..\..\..

if not exist coding\compress\plain_c\makefile goto :skip_compress
echo.
echo src\coding\compress\plain_c
chdir coding\compress\plain_c
%make% -i %clean%
chdir ..\..\..

if not exist coding\compress\PPMII\makefile goto :skip_compress
echo.
echo src\coding\compress\PPMII
chdir coding\compress\PPMII
%make% -i %clean%
chdir ..\..\..

if not exist coding\compress\zlib\makefile goto :skip_compress
echo.
echo src\coding\compress\zlib
chdir coding\compress\zlib
%make% -i %clean%
chdir ..\..\..
:skip_compress

if not exist coding\crypt\makefile goto :skip_crypt
echo.
echo src\coding\crypt
chdir coding\crypt
%make% -i %clean%
chdir ..\..
:skip_crypt

if not exist coding\misc\makefile goto :skip_coding_misc
echo.
echo src\coding\misc
chdir coding\misc
%make% -i %clean%
chdir ..\..
:skip_coding_misc

if not exist geo\plane\real\makefile goto :skip_plane_real
echo.
echo src\geo\plane\real
chdir geo\plane\real
%make% -i %clean% DFLAGS="-I../../../../src/geo/plane/generic"
chdir ..\..\..
:skip_plane_real

if not exist geo\plane\real\makefile goto :skip_plane_alg_real
echo.
echo src\geo\plane_alg\real
chdir geo\plane_alg\real
%make% -i %clean% DFLAGS="-I../generic -I../../../../src/geo/plane_alg/generic"
chdir ..\..\..
:skip_plane_alg_real

if not exist geo\plane_alg\rational\makefile goto :skip_plane_alg_src1
echo.
echo src\geo\plane_alg\rational
chdir geo\plane_alg\rational
%make% -i %clean% DFLAGS="-I../generic -I../../../../src/geo/plane_alg/generic"
chdir ..\..\..
:skip_plane_alg_src1

if not exist string goto :skip_src1_string
echo.
echo src\string
chdir string
%make% -i %clean% DFLAGS="-I../generic"
chdir ..
:skip_src1_string
goto :src1pass

:end

set make=
set wdir=
set clean=

make_dll %1 
