/*******************************************************************************
+
+  LEDA 7.0  
+
+
+  gw_visrep.c
+
+
+  Copyright (c) 1995-2023
+  by Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/


#include<LEDA/graphics/graphwin.h>
#include<LEDA/graph/graph_alg.h>

using namespace leda;

int main()
{
  GraphWin gw;
  gw.set_node_shape(rectangle_node);

  gw.display();

  while(gw.edit())
  {
    graph& G = gw.get_graph();

    node_array<double> x_pos(G);
    node_array<double> y_pos(G);
    node_array<double> x_rad(G);
    node_array<double> y_rad(G);
    edge_array<double> x_sanch(G);
    edge_array<double> y_sanch(G);
    edge_array<double> x_tanch(G);
    edge_array<double> y_tanch(G);

    if (!VISIBILITY_REPRESENTATION(G,x_pos,y_pos,x_rad,y_rad,x_sanch,y_sanch,
                                                             x_tanch,y_tanch))
       continue;

    edge_array<list<double> > x_bends(G);
    edge_array<list<double> > y_bends(G);

    double dx,dy,f;
    gw.fill_win_params(x_pos,y_pos,x_rad,y_rad,x_bends,y_bends,dx,dy,f,f);
    gw.transform_layout(x_pos,y_pos,x_rad,y_rad,x_bends,y_bends,dx,dy,f,f);
    gw.set_layout(x_pos,y_pos,x_rad,y_rad,x_bends,y_bends,
                                          x_sanch,y_sanch,x_tanch,y_tanch);
  }
  
  return 0;
}
