#define LEDA_CHECKING_OFF

#include <LEDA/graph.h>
#include <LEDA/dimacs.h>


int main(int argc, char** argv)
{
  graph G;
  list<node> L;
  node_array<string>  nlabel(G);
  edge_array<string>  elabel(G);

  Read_Dimacs_Graph(cin,G,L,nlabel,elabel);
  cout << endl;

  int n = G.number_of_nodes();
  int m = G.number_of_edges();

  cout << string("%6d nodes",n) << endl;
  cout << string("%6d edges",m) << endl;
  cout << endl;

  node v;
  forall_nodes(v,G)
     cout << nlabel[v] << endl;
  cout << endl;

  edge e;
  forall_edges(e,G)
     cout << elabel[e] << endl;
  cout << endl;

  return 0;
}




