#include <LEDA/d3_window_stream.h>

int main()
{
 window win(500,500,"3d Window Stream");
 win.init(-1000,1000,-1000);

 d3_window_stream DW(win);
 d3_point p(100,200,100);
 d3_point p1(80,50,10),p2(120,130,15);
 d3_line seg(p1,p2);
 d3_plane pl(p,p1,p2);
 
 DW.set_color(red);
 
 DW << p;
 DW << seg;
 DW << pl;
 
 // d3 simplex ...
 d3_point ps1(20,30,30),ps2(70,10,-10);
 d3_point ps3(50,10,100),ps4(60,100,30);
 d3_simplex sim(ps1,ps2,ps3,ps4);
 
 DW.set_color(red);
 DW << sim;
 
 // d3 sphere ...
 vector vec(90,40,30);
 d3_sphere sph(ps1+vec, ps2+vec, ps3+vec, ps4+vec);
 
 DW.set_color(green2); DW << sph;

 DW.show();
 return 0;
}
