#include <LEDA/graph/graph.h>
#include <LEDA/graph/graph_alg.h>
#include <LEDA/graph/dimacs.h>
#include <LEDA/system/assert.h>

using namespace leda;

using std::cin;
using std::cout;
using std::flush;
using std::endl;


int main()
{
  graph G;

  edge_array<int> cap(G,0);
  edge_array<int> cost(G,0);
  edge_array<int> lcap(G,0);
  node_array<int> supply(G,0);

  Read_Dimacs_MCF(cin,G,supply,lcap,cap,cost);

  edge_array<int> flow(G,0);

  float T = used_time();

  bool f = MIN_COST_FLOW(G,lcap,cap,cost,supply,flow) ;
  double c = 0;
  edge e;
  forall_edges(e,G) c += cost[e]*flow[e];
  if (f)
    cout << string("time: %5.2f cost: %12.0f", used_time(T), c) << endl;
  else
    cout << string("time: %6.2f sec. Not feasible.",used_time(T)) << endl;

  
  return 0;
}

