/*******************************************************************************
+
+  LEDA 7.0  
+
+
+  amo.c
+
+
+  Copyright (c) 1995-2023
+  by Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/



#define LEDA_CHECKING_OFF

#include <LEDA/graph/graph.h>
#include <LEDA/graph/graph_alg.h>
#include <LEDA/graph/dimacs.h>
#include <LEDA/system/stream.h>

using namespace leda;

using std::cout;
using std::cerr;
using std::endl;



int main(int argc, char** argv) 
{
  if (argc < 2)
  { cerr << "usage: " << argv[0] << " n" << endl;
    return 1;
   }

  GRAPH<int,int> G;
  edge_array<int>& cap = G.edge_data();
  node s,t;

  int n = string(argv[1]).atoi();

  max_flow_gen_AMO(G,s,t,n);
  Write_Dimacs_MF(cout,G,s,t,cap);
    
 return 0;
}
