#include "my_boost.h"

#include <boost/graph/biconnected_components.hpp>

#include <iomanip>


enum edge_compnum_t { edge_compnum };

namespace boost {
  BOOST_INSTALL_PROPERTY(edge, compnum);
}


using namespace std;

int main(int argc, char* argv[])
{
  typedef boost::adjacency_list<boost::vecS,boost::vecS,boost::undirectedS,
                                no_property, property<edge_compnum_t,int> > Graph;

  typedef graph_traits <Graph> traits;
  typedef traits::vertex_descriptor node;
  typedef traits::vertex_iterator   node_it;
  typedef traits::out_edge_iterator out_edge_it;


  typedef boost_graph<Graph> graph;

  typedef property_map < Graph, edge_compnum_t >::type edge_slot;



/*
int m = 1 << 23;   // 8 Mio

cout << endl;
cout << "m = " << m << endl;
cout << endl;
cout << "BOOST builtin" << endl;
cout << endl;

for (double f = m;  f*(f-1) >= m;  f/=2) 
{
    int n = int(f);
*/


/*
int n; cout << "n = "; cin >> n;
int m; cout << "m = "; cin >> m;
*/


for(int n = 100000; n < 1000000; n += 100000)
{
  int m = 10*n;


  graph G;
  edge_slot compNum = get(edge_compnum, G);

  random_graph(G,n,m);


  cout <<  fixed <<  setprecision(3) << right;

  float T = used_time();
  int bcc_num = boost::biconnected_components(G,compNum);
  cout << setw(7) << n << "  " << setw(5) << used_time(T) << endl; 

}

 return 0;
}


 
