#ifndef _X_BASIC_H
#define _X_BASIC_H

#include <LEDA/system/basic.h>
#include <LEDA/system/assert.h>

#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>
#include <string.h>

#if defined(mips)
#include <bstring.h>
#endif

#if defined(_AIX)
#include <strings.h>
#include <sys/select.h>
#else
#include <sys/time.h>
#include <sys/times.h>
#if !defined(__aCC__)
#include <sys/select.h>
#endif
#endif

#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/keysym.h>
#include <X11/cursorfont.h>
#include <X11/Xresource.h>
#include <X11/Xft/Xft.h>

#include <LEDA/graphics/x_window.h>


LEDA_BEGIN_NAMESPACE

#include <LEDA/graphics/x_basic.h>



#define TOOLTIP_MAX 128
struct x11_tooltip;

struct  x11_win
{
  Drawable     win;
  Drawable     win_save;
  Drawable     win_save2;
  Drawable     buf;
  Drawable     win_tt;

  // required for OpenGL

  Drawable     win_ret;
  void*        glc_ret;
  void*        glc;

  Pixmap       clip_mask;

  int          buf_w;
  int          buf_h;

  XGCValues    gc_val;
  GC           gc;
  GC           gc_tt;


  XftDraw*     xft_draw;

  XftFont*     xft_font;
  int          xft_size;

  XftFont*     xft_last_font;
  int          xft_last_size;


  int          LINEWIDTH;
  line_style   LINESTYLE;
  int          JOINSTYLE;
  drawing_mode MODE;
  text_mode    TEXTMODE;
  int          COLOR;
  int          BG_COLOR;
  char*        BG_PIXMAP;

  int          mapped;

  void* inf;

  int resizing;

  void (*redraw)(void*,int,int,int,int,int);
  void (*special_event_handler)(void*, const char*, const char*, int, int);
  unsigned long special_event_data;

  Window  icon_win;
  Window  frame_win;
  Cursor  cursor;
  int     cursor_id;
  int     BORDER_COLOR;
  int     BORDER_COLOR_SAVE;


  x11_tooltip** tt_top;
  x11_tooltip*  tt_stack[TOOLTIP_MAX];

  x11_win() { memset(this,0,sizeof(x11_win)); }
};

const int MAXWIN = 256;

LEDA_END_NAMESPACE

#endif
